︠afa0c863-d599-4aa2-9b1b-f5696fc04b15s︠
%auto
typeset_mode(True, display=False)
︡1fd5fa57-92d5-4d07-a61c-7bc44d8f67fd︡{"done":true,"error":"maximum time (=30000ms) exceeded - last error true"}︡
︠d79ee297-d940-4e04-8186-48bda36c06dci︠
%md
# **INTERPOLAÇÃO E AJUSTE DE CURVAS**

## **Interpolação**


︡6e98eebd-fcad-4272-b087-5ea21b5489da︡{"done":true,"md":"# **INTERPOLAÇÃO E AJUSTE DE CURVAS**\n\n## **Interpolação**"}
︠b7adf1dd-76e8-4b5d-bf04-28dc8ce41b13i︠
%md
### **Função Interp1d.**

‘linear’, ‘nearest’, ‘zero’, ‘slinear’, ‘quadratic, ‘cubic’ where ‘slinear’, ‘quadratic’ and ‘cubic’ refer to a spline interpolation of first, second or third order) or as an integer specifying the order of the spline interpolator to use. Default is ‘linear’.
︡b9492d76-9787-4055-9730-bf6626fd4b22︡{"done":true,"md":"### **Função Interp1d.**\n\n‘linear’, ‘nearest’, ‘zero’, ‘slinear’, ‘quadratic, ‘cubic’ where ‘slinear’, ‘quadratic’ and ‘cubic’ refer to a spline interpolation of first, second or third order) or as an integer specifying the order of the spline interpolator to use. Default is ‘linear’."}
︠f8e3ba6b-6d59-4848-b680-7ee807210713s︠
x = [0,0.50,1,1.50,2,2.50,3,3.50,4,4.50,5]

y = [1,3,4,6,9,7,8,4,3,8,10]
︡4fe87be6-6152-41ec-9205-2d88c004d575︡{"done":true}︡
︠ba94c3c4-4edd-4c67-a932-b63d5cabe318s︠
from scipy.interpolate import interp1d
︡05f5206a-e002-4385-bde4-5aef738c272f︡{"done":true}︡
︠5eba72e0-64a1-4469-9cbd-25a50e3fc79ei︠
%md
* **Linear **
︡42313704-3aa7-4200-8dc2-3b180b99ca7f︡{"done":true,"md":"* **Linear **"}
︠ad247cb8-00f1-4714-bf01-cf2aa8029f36s︠

f_int_linear = interp1d(x,y,kind = 'linear')

f_int_linear
︡bd7a7b87-23a3-4a4b-9545-4814d11b8fc0︡{"stdout":"<scipy.interpolate.interpolate.interp1d object at 0x7fb71f17ffc8>\n"}︡{"html":"<div></div>"}︡{"done":true}︡
︠51c6ae54-e8df-4985-9c31-8f29b75a05bfs︠
# testando

f_int_linear(1.8)
︡ecf8e9cb-a638-4909-825e-8fed218ed5fc︡{"html":"<div>$7.8$</div>"}︡{"done":true}︡
︠772300f9-5744-4140-9901-4d87d2ddcb51i︠
%md
* **Cubica**
︡f99d8988-99ad-4fef-a696-cb4804bf85a2︡{"done":true,"md":"* **Cubica**"}
︠16df5da8-707a-4380-b5bf-e96f4f3fa86es︠
f_int_spcubic = interp1d(x,y,kind = 'cubic')

f_int_spcubic
︡f6dd3407-d826-4a0d-bcae-3eadc7b099d2︡{"stdout":"<scipy.interpolate.interpolate.interp1d object at 0x7fb71f17fba8>\n"}︡{"html":"<div></div>"}︡{"done":true}︡
︠7bc663aa-149d-4e48-9c3f-63acbbb97d40s︠
# Testando

f_int_spcubic(1.8)
︡f18eb013-62af-4a79-9d03-9fddb56a20a0︡{"html":"<div>$8.27956201914$</div>"}︡{"done":true}︡
︠004d1fd2-4a06-4a8f-8903-cc169347aa9ai︠
%md
* **Quadratica**
︡d2601e66-3a68-4f16-8a6e-3f9ec8dd452b︡{"done":true,"md":"* **Quadratica**"}
︠99386866-cf0c-4d80-be7a-895d252a12bds︠
f_int_quad = interp1d(x,y,kind = 'quadratic')

f_int_quad
︡12103022-2e5e-451b-9d31-486b40628894︡{"stdout":"<scipy.interpolate.interpolate.interp1d object at 0x7fb71f17f260>\n"}︡{"html":"<div></div>"}︡{"done":true}
︠3456df24-1702-48da-94d4-3dc2980cc67fs︠
# Testando

f_int_quad(1.8)
︡2d639925-d870-4925-8c59-19889215adfe︡{"html":"<div>$9.26666666667$</div>"}︡{"done":true}︡{"html":"<div>$9.26666666667$</div>"}︡{"done":true}
︠f23a4b73-cb67-4757-b46a-a4a8e384b7fes︠
point(zip(x,y), legend_label='pontos',size = 30,gridlines='minor', figsize=(6, 5)) + plot(f_int_linear,(0,5),legend_label='Int.Linear',color='red',figsize=(6, 5)) + plot(f_int_spcubic,(0,5),legend_label='Int.Cubic',color='black') + plot(f_int_quad,(0,5),legend_label='Int.Quad',color='green')
︡6e46966d-506b-4fec-98bf-18780f1fc1e5︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_zLXXPt.svg","show":true,"text":null,"uuid":"7b0f2040-dd09-4f3c-894b-ff36236a02b0"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠c13de327-64ff-4302-9bdb-37107eb144a6i︠
%md
### **Função Spline**

︡54329668-054b-45d4-9949-3e3a9fb97f33︡{"done":true,"md":"### **Função Spline**"}
︠47a2ce0c-35c0-45fb-afa8-737168eff5dfs︠
x = [0,0.50,1,1.50,2,2.50,3,3.50,4,4.50,5]

y = [1,3,4,6,9,7,8,4,3,8,10]
︡4ab3d085-e8c6-45d3-81cd-b29bebe5d95e︡{"done":true}︡
︠111d0236-d801-4d8c-876c-1b20db026334s︠
pontos = zip(x,y)
︡72a390e0-b018-440c-92c8-b6749f290744︡{"done":true}︡
︠788ae693-d1b0-4716-ae93-25c38fc2517bs︠
point(pontos, legend_label="pontos",size = 30,gridlines="minor", figsize=(6, 5))
︡42d012d5-9234-42f7-bf58-1bdb4eda0217︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_RVyxjZ.svg","show":true,"text":null,"uuid":"df445597-f1bf-477b-8e8e-e341db24f85c"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠53fad9bd-f06c-42ab-a29d-100c69713377s︠
f_spline  = spline(pontos)
︡0f1a4380-330c-4559-8cd4-bfcb56e5fe8a︡{"done":true}︡
︠c9a62b2c-cb5e-4a7d-91e1-ab558c87af22i︠
%html
<p>Saber qual &eacute; o ponto &nbsp;correspondente a x = 0.2</p>

︡d665a193-4854-4aec-8a74-cdc262cd52f7︡{"done":true,"html":"<p>Saber qual &eacute; o ponto &nbsp;correspondente a x = 0.2</p>"}
︠488e2e94-8399-469a-945e-b65630f670ffs︠
f_spline(0.2)
︡9d8bea21-c4a0-4318-a08b-d8303d0e7b05︡{"html":"<div>$1.89697671099$</div>"}︡{"done":true}︡{"done":true}︡
︠5e8b1062-0c27-46aa-89f9-6006b14b0476s︠
point(pontos, legend_label="pontos",size = 30,gridlines="minor", figsize=(6, 5)) + plot(f_spline,(0,5),legend_label="spline", color = "red", gridlines="minor");
︡c2fd90a3-177f-4393-9f49-64edf4d3db41︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_hLfJq7.svg","show":true,"text":null,"uuid":"c03db84c-d665-4167-afa0-b22d1d698c65"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠8475eb14-b354-40e7-a347-6846b4b52044i︠
%md
## **Ajuste de Curvas**
### **Ajuste Linear**

︡931ef9ba-0c0e-41b0-a3b8-e89817903f77︡{"done":true,"md":"## **Ajuste de Curvas**\n### **Ajuste Linear**"}
︠bef35639-82f3-4ec5-ba0a-6f8decd85062s︠
reset();
︡016ac293-a5db-4aaa-9a3c-0284dfcd6463︡{"done":true}︡
︠197d59ae-9275-463b-a294-32a9b9346023s︠
var("a,b,x,y")
︡b6e99a3b-d010-4f55-96d3-f55201947393︡{"html":"<div>($a$, $b$, $x$, $y$)</div>"}︡{"done":true}︡
︠4a4ca379-52a4-4d82-a34e-4a3b0a5daf75s︠
import csv
︡95c97c1e-a5ae-49f9-b3d0-966190651bc0︡{"done":true}︡
︠8e6487f6-7151-4953-a042-771717e992fbi︠
%md
faça o upload do arquivo "tabela_reta.csv"

︡86b16d1f-1e21-4931-b2a5-da86f7426d4f︡{"done":true,"md":"faça o upload do arquivo \"tabela_reta.csv\""}
︠d54b471a-21f0-4edc-886c-39d45efc269bs︠
import pandas as pd
︡094156aa-4ec1-49e5-a56e-a388845ca803︡{"done":true}︡
︠9f9c248c-e43d-4fab-a12e-afa08d22d7aas︠
dados_reta = pd.read_csv('dados_reta.csv')
︡fb3e348e-70df-4a96-8b19-4c87a0ca27f0︡{"done":true}︡
︠a16aa59b-5a57-4c8b-9a20-0517c54ac20ds︠
pontos = zip(dados_reta.x,dados_reta.y)
︡d232ee87-5cfb-449b-bf3f-7ab6ec7a1441︡{"done":true}︡
︠e8b60f6e-15b2-41b8-afc2-5714de911905s︠
points(pontos,color = "red",size=20,legend_label="pontos coletados",gridlines="minor", figsize=(6, 5))
︡4fe8911c-c32a-4b4f-b42a-c9b0e1e34d11︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_DiPlzo.svg","show":true,"text":null,"uuid":"6960b203-dd07-43a4-91f6-387f9d6a1fc3"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠8f27f711-b3b6-417b-b139-0a577b2cfb82s︠
modelo_reta(x) = a*x + b; modelo_reta
︡d30c7d8f-446f-49f4-8314-637d86331ad6︡{"html":"<div>$x \\ {\\mapsto}\\ a x + b$</div>"}︡{"done":true}︡
︠1a5b277a-6da7-472a-84e8-32e33fa2f9abs︠
# A opção solution_dict=True,utilizada para criar o dicionários das constantes, é opcional, mas caso não ocorra erro, coloque-a como true

ajuste = find_fit(pontos, modelo_reta,[0.5,0.5],solution_dict=True); ajuste
︡d430b605-2617-480a-9fa6-d3ee86605a43︡{"html":"<div>$\\left\\{a : 0.459962266452, b : -0.175732173045\\right\\}$</div>"}︡{"done":true}︡
︠e3624f0b-380c-48c1-8f78-aa54606a769esi︠
ajuste[b]
︡e77ebc71-7149-4841-8860-e686d67b767b︡{"html":"<div>$-0.175732173045$</div>"}︡{"done":true}︡
︠edbec1ac-50ca-4001-9a21-7ca9003bbfc6s︠

︡c42171d1-2ab3-44b2-ba23-27d2af7441d6︡{"done":true}︡
︠8f10b25d-fe1c-4a84-923d-fe886038d879s︠
modelo_reta_ajustado(x) = modelo_reta.subs(ajuste);modelo_reta_ajustado(x)
︡336341ce-7f99-4756-bcba-3bd20ef37c3a︡{"html":"<div>$0.459962266452 \\, x - 0.175732173045$</div>"}︡{"done":true}︡
︠7ed4dca5-5a84-4f94-adf7-144c8bcbb09ds︠
point(pontos,color = "red",size=20,legend_label="pontos coletados",gridlines="minor", figsize=(6, 5)) + plot(modelo_reta_ajustado(x),(x,0,3.5),legend_label="reta ajustada")
︡39ae0f1e-1ea9-45ad-b963-da0baa7cc598︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_c0kTsn.svg","show":true,"text":null,"uuid":"76c029bf-bf39-4529-8aa1-3dd5f44fe05f"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠6d8f23ec-79a0-4d4d-9d3f-0c0cc52a79e1i︠
%md
### **Polinomial (GRAU>1)**

ATENÇÃO! É importante resetar as variaveis antes de usar os outros modelos de ajuste de curvas, pois as constantes a,b,c são as mesmas em todos os modelos
︡b993fc5f-714f-4d81-b22d-ea097ed28112︡{"done":true,"md":"### **Polinomial (GRAU>1)**\n\nATENÇÃO! É importante resetar as variaveis antes de usar os outros modelos de ajuste de curvas, pois as constantes a,b,c são as mesmas em todos os modelos"}
︠c3e0660c-8534-4753-be04-d020c54913c2s︠
reset()
︡ea24d0b5-4ee4-409d-9c31-6b808796da1d︡{"done":true}︡
︠437b9cb6-2edc-4118-9c4f-a01de943abcds︠
var("a, b, c, x")
︡ed221ebd-947c-4ee6-bbe4-629c4b0b2eb9︡{"html":"<div>($a$, $b$, $c$, $x$)</div>"}︡{"done":true}︡
︠2d2b89bc-c58c-4434-be59-7186e4e53f46s︠
import pandas as pd
︡50bc7431-3f28-4011-981d-a10e9e2492d4︡{"done":true}︡
︠166cf590-4809-466e-8d67-67b3b2a045e4s︠
dados_parabola = pd.read_csv('dados_parabola.csv')
︡20787355-5b27-4211-b1d4-03f2d4b960f2︡{"done":true}︡
︠e5f15039-af31-4c6d-9aa2-614445b37014s︠
pontos = zip(dados_parabola.x,dados_parabola.y)
︡8c0d81bd-d9d2-4602-ba08-1378db81f9ca︡{"done":true}︡
︠2451e0ab-3460-42bb-98bd-3aa2ba646305s︠
point(pontos,color = "red",size=20,legend_label="pontos coletados", gridlines="minor", figsize=(6, 5))
︡d6588581-be10-474e-88fc-476411bd6bc9︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_2JkbGc.svg","show":true,"text":null,"uuid":"c4c459d8-16df-4871-8d1b-ed2f0ec98fb2"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠edfa0b45-0eb4-45b9-b500-1dbcdeee6f39s︠
modelo_polinomial(x) = a*x^2 + b*x + c; modelo_polinomial
︡de171ae9-a88b-4404-b227-76ffe637e1ce︡{"html":"<div>$x \\ {\\mapsto}\\ a x^{2} + b x + c$</div>"}︡{"done":true}︡
︠93c2d0cc-f69a-4a32-b434-4eeebb0ed864s︠
# A opção solution_dict=True,utilizada para criar o dicionários das constantes, é opcional, mas caso não ocorra erro, coloque-a como true

ajuste = find_fit(pontos, modelo_polinomial,[0.5,0.5,0.5],solution_dict=True)

ajuste
︡0b8836a2-929f-468c-92f0-bbf4d16eec91︡{"html":"<div>$\\left\\{a : -0.967693528236, b : 9.76313986539, c : 0.259156519225\\right\\}$</div>"}︡{"done":true}︡
︠d955c8d1-4c83-426b-88cd-f4ea57dfe691s︠
modelo_polinomial_ajustado(x) = modelo_polinomial.subs(ajuste)

modelo_polinomial_ajustado(x)
︡11bd7e9c-a925-4ac0-a3ec-6c7d668f1a32︡{"html":"<div>$-0.967693528236 \\, x^{2} + 9.76313986539 \\, x + 0.259156519225$</div>"}︡{"done":true}︡
︠b0762d49-6a6b-40f6-b770-d1ddee05456fs︠
point(pontos,color = "red",size=20,legend_label="pontos coletados",gridlines="minor", figsize=(6, 5)) + plot(modelo_polinomial_ajustado(x) ,(x,0,10),legend_label="curva ajustada")
︡2e9cb453-7def-4f01-b284-b045344d04a6︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp__JKf7X.svg","show":true,"text":null,"uuid":"5aa9d7a2-124d-41ff-affc-b2f53cb391f0"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠01f2dfc6-f936-4d15-9713-e46848a40320i︠

%md

### ** Não Polinomial** ###

ATENÇÃO! É importante resetar as variaveis antes de usar os outros modelos de ajuste de curvas, pois as constantes a,b,c são as mesmas em todos os modelos

︡1df9fd34-be9d-4869-9c0d-890ee8bfac1d︡{"done":true,"md":"\n### ** Não Polinomial** ###\n\nATENÇÃO! É importante resetar as variaveis antes de usar os outros modelos de ajuste de curvas, pois as constantes a,b,c são as mesmas em todos os modelos"}
︠85647ea5-8b38-4a7e-b162-09ad49104114s︠
reset()
︡7c8db106-2770-40bd-ac93-1fb59d5367e8︡{"done":true}︡
︠2340460b-3d0b-4754-8fac-b00306b35043s︠
var("a,b,c,x")
︡aae8ab31-317c-4c49-a13b-e9bc1e657dec︡{"html":"<div>($a$, $b$, $c$, $x$)</div>"}︡{"done":true}︡
︠7a6ccb30-c524-4280-8212-9020997f930es︠
import pandas as pd
︡bea1eb8f-5504-48f1-bb5f-9de4366a9fc3︡{"done":true}︡
︠bc3d761e-e598-43d3-861f-67b2d4d3b360s︠
dados_senoide = pd.read_csv('dados_senoide.csv')
︡7baf5713-1f97-4445-b07b-03e9fb8f743e︡{"done":true}︡
︠07f31c5a-b961-4310-8e13-bddc2e885677s︠
pontos = zip(dados_senoide.x,dados_senoide.y)
︡f85bc43b-32b6-45af-bd8b-17d0b19940e3︡{"done":true}︡
︠d094d739-55e6-407b-88f0-d86687d831ecs︠
point(pontos,color = "red",size=20,legend_label="pontos coletados",gridlines="minor", figsize=(6, 5))
︡b443bae3-0262-4089-b0ea-d9c22458ebab︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_bwkAAh.svg","show":true,"text":null,"uuid":"7f225a2d-0bdd-423f-b378-954e8fa35c70"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠2cad2e05-b4b6-46b0-8d27-37c54c5d18fbs︠
modelo_seno(x) = a*sin(b*x + c);

modelo_seno(x)
︡d8e5b845-4696-4be3-a853-b024a76b4d15︡{"html":"<div>$a \\sin\\left(b x + c\\right)$</div>"}︡{"done":true}︡
︠e077bf07-a2c3-409a-9949-3c15f31ab5d0s︠
# A opção solution_dict=True,utilizada para criar o dicionários das constantes, é opcional, mas caso não ocorra erro, coloque-a como true

ajuste = find_fit(pontos, modelo_seno,[0.5,0.5,0.5],solution_dict=true);ajuste
︡d73bb007-3d6a-46c3-b4a5-e020f2a612ee︡{"html":"<div>$\\left\\{a : 1.19210756633, b : 0.494283899862, c : -0.198753779578\\right\\}$</div>"}︡{"done":true}︡
︠aad52ec6-dbf7-4c60-ae38-1c50ed31b768s︠
modelo_seno_ajustado(x) = modelo_seno.subs(ajuste);modelo_seno_ajustado(x)
︡662009d6-5afc-446f-8aaf-2832232b51d5︡{"html":"<div>$1.19210756633 \\, \\sin\\left(0.494283899862 \\, x - 0.198753779578\\right)$</div>"}︡{"done":true}︡︡{"done":true}
︠3e761ddb-856c-4ff6-aab7-f90d237f940ds︠
point(pontos,color = "red",size=20,legend_label="pontos coletados",gridlines="minor", figsize=(6, 5))+ plot(modelo_seno_ajustado(x),(x,0,12),legend_label="curva ajustada")
︡b9a0205d-a5a9-40a6-96c5-c0e2171b3550︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/29858/tmp_YEP1I1.svg","show":true,"text":null,"uuid":"beab7799-35bd-4238-86e2-4c5738812865"},"once":false}︡︡{"html":"<div align='center'></div>"}︡{"done":true}{"html":"<div align='center'></div>"}︡{"done":true}︡
︠dda9cc9b-8901-4bdd-ab1d-7418c403fc88i︠
%md
** %%% FIM INTERPOLA&Ccedil;&Atilde;O E AJUSTE DE CURVAS %%% **

︡bf859351-fce6-4b0a-b745-4837b5c59e58︡{"done":true,"md":"** %%% FIM INTERPOLA&Ccedil;&Atilde;O E AJUSTE DE CURVAS %%% **"}
︠9cc9a624-4a2b-46d7-a614-7ca007829743s︠

︡08650dfd-aa79-4e0e-b3f7-f6928437d42e︡{"done":true}︡{"done":true}









